function [mask3]=sacr_masking_iter_2(range,velo,ele,mode)
% -------------------------------------------------------------------------
%*Function* sacr_masking_iter_2.m
% @version sacr 1.1

% *SRC_FILE*
% sacrm/sacr_masking_iter_2.m

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%% INPUTS %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
% ele            : elevation angle  (degrees)
% velo           : doppler velocity  (m/s)
% range          : radar range (m)
% mode           : scanning mode

%%%%%%%%%%%%%%%%%%%%%%%% OUTPUTS %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% mask3          : location of the pixels containing "bad data"
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



%  This program  contains the subroutines needed for procesing raw sacr data
%
%
%  Copyright (C) 2014 McGill Clouds Research Group (http://www.clouds.mcgill.ca/)
%  Contact email address: pavlos.kollias@mcgill.ca, aleksandra.tatarevic@mcgill.ca,
%  iengjo@meteo.mcgill.ca
%
%  This source code is free software: you can redistribute it and/or modify
%  it under the terms of the GNU Lesser General Public License as published by
%  the Free Software Foundation, either version 3 of the License, or
%  any later version.
%
%  This program is distributed in the hope that it will be useful,
%  but WITHOUT ANY WARRANTY; without even the implied warranty of
%  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%  GNU Lesser General Public License for more details.
%
%  You should have received a copy of the GNU Lesser General Public License
%  along with this program.  If not, see <http://www.gnu.org/licenses/>.
%
% ----------------------------------------------------------------------------



%%%%%% Calculate variables size %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

R = length(ele);
E = length(range);
ibox=2;
  
     

mask3= zeros(size(velo));
 
  
  
for e=1:E;    
    
j1=nanmin(e+1-ibox,ibox);j2=abs(nanmax(e-E,-ibox));
    
    for r=1:R;
        
        if ~isnan(velo(r,e)) 
             
         i1=nanmin(r+1-ibox,ibox);i2=abs(nanmax(r-R,-ibox));
         
            if sum(sum(isnan(velo(r-i1:r+i2,e-j1:e+j2))))<10;   
               mask3(r,e) = 1; %% good pixel
           
            end
        end
   
     end
    
end
    
  
 end
